


;******************************************************************************
;   2313
;******************************************************************************

.include 	"tn2313adef.inc"	;  tiny2313a



;******************************************************************************
; 
;******************************************************************************

.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20	;   SREG
.def	Temp5=R21
.def	Temp6=R22	;   ( 0=, 1=, 2=_1, 3=_2 )
.def	Temp7=R23
.def	Temp8=R24
.def	Temp9=R25




;******************************************************************************
; 
;******************************************************************************


.dseg			;

ch_count: .byte 1	;     
			; 0 - 
			; 1 - _1
			; 2 - _2


;******************************************************************************
; 
;******************************************************************************

.EQU Imp_1=0xCE4 			;  _1  (165 )
.EQU Log_0=0xCE4 			;    (165 )
.EQU Imp_2=0x19C8			;  _2 (330 )  
.EQU Sinhron=0x3390			;    (660 )


;******************************************************************************
; 
;******************************************************************************

.cseg



.org 0
rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset



.org   OC1Aaddr				; (=0x0004) Timer/Counter1 Compare Match A (   _1 )
rjmp OCR1A_COMP



.org INT_VECTORS_SIZE			;   


;******************************************************************************
;
;******************************************************************************

reset:						;  


;*******************************************************************************
;    
;*******************************************************************************


	cli					;    




;*******************************************************************************
;  
;*******************************************************************************

	ldi Temp,low(RamEnd)			;  	
	out SPL,Temp				;



;*******************************************************************************
;  
;*******************************************************************************
	
	ldi Temp,0b00001000			;   "" (0-, 1-)
	out DDRB,Temp				; 0000000 - ""   ( PB3- 15  - OC1 )
						; 1 - "" 
						

	Ldi Temp, 0b00000000			;  _0   ""
	out PORTB,Temp
												 
	ldi Temp,0b00000000			;   "D" (0-, 1-)
	out DDRD,Temp 				;  - 


;*******************************************************************************
;  
;*******************************************************************************					

;  OC1A


	ldi R16,(1<<COM1A1)|(0<<COM1A0)		;   _0    "B",    "OC1A")
	out TCCR1A,R16


	ldi R16,(1<<FOC1A)			;     OC1A  OC1B!!!
	out TCCR1C,R16 


	ldi R16,0b00000000			;     
	out TCCR1C,R16 


;  


	LDI R19,0xFF				;   
	OUT OCR1AH,R19				;      
	LDI R19,0xFF
	OUT OCR1AL,R19   


;  

	ldi Temp,(1<<COM1A0)			;   "OC1A"   ( OC1 = PB3 = 15 )
	out TCCR1A,Temp				; *1


	ldi Temp,(1<<wgm12)|(1<<cs10)		;   "CTC" (  *1) 
	out TCCR1B,Temp				;     = CK 1:1 
						;   !!!


;  

	ldi Temp,0				;   
	out TCNT1H,Temp
	out TCNT1L,Temp



;   

	ldi Temp,(1<<OCIE1A)			;    
	out TIMSK,Temp


;*******************************************************************************
;   
;*******************************************************************************


	sei					;   
        


;*******************************************************************************
;  
;*******************************************************************************

	ldi Temp6, 0				;  



;*******************************************************************************
;    
;*******************************************************************************

	LDI Temp, 0				; 
	STS ch_count, Temp			; 


;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle				; 




;*******************************************************************************
; 
;*******************************************************************************

OCR1A_COMP:


				
;****************************************************************************************************************


	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4


;****************************************************************************************************************



	CPI Temp6, 0
	BREQ transmitt_sinhroimpuls	;   

	CPI Temp6, 1
	BREQ transmitt_log_0		;   

	CPI Temp6, 2
	BREQ transmitt_impuls_1		;     

	CPI Temp6, 3
	BREQ transmitt_impuls_2		;     














;****************************************************************************************************************
;     



transmitt_sinhroimpuls:


;    (   )    


	LDI Temp, 0			; =
	STS ch_count, Temp		; 



;   


	LDI R19, High(Sinhron)		;   
	OUT OCR1AH,R19			;      
	LDI R19, Low(Sinhron)
	OUT OCR1AL,R19  


	ldi Temp6, 1			;      

	rjmp int_reti			; 











;****************************************************************************************************************
;     


transmitt_log_0:


	LDI R19,High(Log_0)		;   
	OUT OCR1AH,R19			;      
	LDI R19,Low(Log_0)
	OUT OCR1AL,R19  




;    (   )     


	LDS Temp, ch_count		;  ()   "ch_count"  "Temp"


	CPI Temp, 0			;    ???

	BRNE impuls_kn_1		;        
					;    ,     

impuls_sinhr:

	ldi Temp6, 2			;        

	rjmp int_reti			; 





impuls_kn_1:

	CPI Temp, 1			;     ???

	BRNE impuls_kn_2		;   ,       
					;    ,     


	ldi Temp6, 3			;        

	rjmp int_reti			; 




impuls_kn_2:				;      

	ldi Temp6, 0			;     

	rjmp int_reti			; 





;****************************************************************************************************************
;       


transmitt_impuls_1:

;    (   )  


	LDI Temp, 1			; =_1
	STS ch_count, Temp		; 


;      

 

	IN Temp, PIND			;    ""

	andi Temp, 0b00000001		;   ,    "0" () 



	CPI Temp, 0b00000001
	BREQ knopka_1_nazata		;  



knopka_1_ne_nazata:

	LDI R19,High(Imp_1)		;   
	OUT OCR1AH,R19			;      
	LDI R19,Low(Imp_1)
	OUT OCR1AL,R19  


	ldi Temp6, 1			;      

	rjmp int_reti			; 


;************************************************


knopka_1_nazata:


	LDI R19,High(Imp_2)		;   
	OUT OCR1AH,R19			;      
	LDI R19,Low(Imp_2)
	OUT OCR1AL,R19  





	ldi Temp6, 1			;      

	rjmp int_reti			; 


;****************************************************************************************************************
;       


transmitt_impuls_2:



;    (   )  


	LDI Temp, 2			; =_2
	STS ch_count, Temp		; 

;      

 

	IN Temp, PIND			;    ""

	andi Temp, 0b00000010		;   ,    "0" () 



	CPI Temp, 0b00000010
	BREQ knopka_2_nazata		;  



knopka_2_ne_nazata:

	LDI R19,High(Imp_1)		;   
	OUT OCR1AH,R19			;      
	LDI R19,Low(Imp_1)
	OUT OCR1AL,R19  





	ldi Temp6, 1			;      

	rjmp int_reti			; 



;************************************************

knopka_2_nazata:


	LDI R19,High(Imp_2)		;   
	OUT OCR1AH,R19			;      
	LDI R19,Low(Imp_2)
	OUT OCR1AL,R19  





	ldi Temp6, 1			;      

	rjmp int_reti			; 







;****************************************************************************************************************
; 


int_reti:



	pop temp4			;  "SREG" ////////////////////////////////////////////////////////////
	out SREG, temp4


	RETI				;    


;****************************************************************************************************************
















