

;					--|__|--|__|--------|__

;******************************************************************************
;   
;******************************************************************************

.include 	"tn2313adef.inc"	;  tiny2313a


;******************************************************************************
;  
;******************************************************************************

.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   SREG
.def	Temp5=R21
.def	FlagFazy=R22			;   ( 0=, 1= , 2=  )
.def	FlagSinhr=R23			;   ( 1=, 0= )
.def	Temp8=R24
.def	Temp9=R25



;******************************************************************************
; 
;******************************************************************************


.dseg					; 

OZU: .byte 2				;  2   



;******************************************************************************
;  
;******************************************************************************


.cseg			



.org 0

rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset (   )




.org INT0addr				; = 0x0001 External Interrupt Request 0 (    INT0 )

rjmp INT_0




.org INT_VECTORS_SIZE			;   




;******************************************************************************
; 
;******************************************************************************

reset:					;  


;******************************************************************************
;   
;******************************************************************************

	cli				;    


;******************************************************************************
;  
;******************************************************************************

	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;


;******************************************************************************
;  
;******************************************************************************
	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 
					
	

	ldi Temp,0b00000000		;  _0   "B"
	out PortB,Temp			;

			
												 
	ldi Temp,0b01111011		;   "D" (0-, 1-)
	out DDRD,Temp 			; 0000000 -     PD2
					; 


 
	ldi Temp,0b00000000		;  _0   "D" //   PD2 .
	out PortD,Temp			;





;******************************************************************************
;   
;******************************************************************************


	ldi Temp,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,Temp


	ldi Temp,(1<<INT0)		;     INT0
	out GIMSK ,Temp



;******************************************************************************
;  
;******************************************************************************
	
	ldi Temp,(1<<cs10)		;    = CK 1:1 ( 1   = 1  )
	out TCCR1B,Temp	


	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp





;******************************************************************************
;  
;******************************************************************************

	ldi FlagFazy, 0			;   ( 0=, 1= , 2=  )

	Ldi FlagSinhr, 0		;   ( 0= , 1= )




;******************************************************************************
;   
;******************************************************************************

	sei				;   
	




;*******************************************************************************
; 
;*******************************************************************************
	

	ldi Temp1, 0
	ldi Temp2, 0
	ldi Temp3, 10

Loop:

	dec Temp1
	brne Loop

	dec Temp2
	brne Loop

	dec Temp3
	brne Loop



;*******************************************************************************
;*******************************************************************************
;  
;*******************************************************************************
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;  
;*******************************************************************************

INT_0:
	


	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in Xl,TCNT1L			;     "X"   "TCNT1"
	in Xh,TCNT1H



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp



;***************************************************************************************
;  
;***************************************************************************************


	cpi FlagSinhr, 0		;  ?
	brne work			;   ,    

;   ,  




sinhro:

	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x3F			;     "Y"  + 0x3FAC
	ldi YL,0xAC



	rcall compare_XY16		; ...

	breq bolshe			;     X=Y 
	brcs menshe			;     X<Y
	rjmp bolshe			;     X>Y 




;*****************************************************************************************
; ...
;*****************************************************************************************




bolshe:					;  ! 


	Ldi FlagSinhr, 1		;   ( 0= , 1=  )


	ldi FlagFazy, 1			;   ( 0=, 1= , 2=  )
					;    

	rjmp out_1			; 






menshe:					;    !

	rjmp out_1			; 





;**************************************************************************************************************
;  ,  
;**************************************************************************************************************

work:		

	cpi FlagFazy, 0			;   ?
	brne command_1_2		;  ,    
	



;   




	mov Temp,XH			;    
	mov Temp1,XL



	ldi YH,0x3F			;     "Y"  + 0x3FAC
	ldi YL,0xAC



	rcall compare_XY16		; ...

	breq duration_mismatch_1	;     X=Y 
	brcs duration_mismatch_1	;     X<Y
	rjmp bolshe_3FAC		;     X>Y 


duration_mismatch_1:

	rjmp duration_mismatch		;  


bolshe_3FAC:



	mov Temp,XH			;    
	mov Temp1,XL



	ldi YH,0x41			;     "Y"  + 0x413C
	ldi YL,0x3C



	rcall compare_XY16		; ...

	breq duration_mismatch_2	;     X=Y 
	brcs menshe_413C		;     X<Y
	rjmp duration_mismatch		;     X>Y 


duration_mismatch_2:

	rjmp duration_mismatch		;  



menshe_413C:				;    


	ldi FlagFazy, 1			;     


	rjmp out_1			; 




;**************************************************************************************************************
; 
;**************************************************************************************************************

command_1_2:				;      




	mov Temp,XH			;   
	mov Temp1,XL



	ldi YH,0x19			;     "Y"  + 0x1996
	ldi YL,0x96



	rcall compare_XY16		; ...

	breq duration_mismatch		;     X=Y 
	brcs duration_mismatch		;     X<Y
	rjmp bolshe_1996		;     X>Y 






bolshe_1996:


	mov Temp,XH			;    
	mov Temp1,XL



	ldi YH,0x19			;     "Y"  + 0x19FA
	ldi YL,0xFA



	rcall compare_XY16		; ...

	breq bolshe_19FA		;     X=Y 
	brcs menshe_19FA		;     X<Y
	rjmp bolshe_19FA		;     X>Y 






menshe_19FA: 				;   


;         


	cpi FlagFazy, 1			;   ?
	brne channel_2_off		;  ,    



;******************************************************************************************************
;  
;******************************************************************************************************
	
channel_1_off:				;   


	in Temp, PINB			;   "B"


	andi Temp, 0b11111110		;  "1"   ,  "0"   ! () 


	ldi Temp1, 0b00000000		;


	OR Temp, Temp1			; _ 


	out PortB, Temp			;   




	ldi FlagFazy, 2			;    


	rjmp out_1			; 





channel_2_off:				;   



	in Temp, PINB			;   "B"


	andi Temp, 0b11111101		;  "1"   ,  "0"   ! () 


	ldi Temp1, 0b00000000		;


	OR Temp, Temp1			; _ 


	out PortB, Temp			;   




	ldi FlagFazy, 0			;   


	rjmp out_1			; 


;******************************************************************************************************
; 
;******************************************************************************************************


bolshe_19FA:



	mov Temp,XH			;    
	mov Temp1,XL



	ldi YH,0x26			;     "Y"  + 0x267A
	ldi YL,0x7A



	rcall compare_XY16		; ...

	breq duration_mismatch		;     X=Y 
	brcs duration_mismatch		;     X<Y
	rjmp bolshe_267A		;     X>Y 




bolshe_267A: 


	mov Temp,XH			;    
	mov Temp1,XL



	ldi YH,0x26			;     "Y"  + 0x26DE
	ldi YL,0xDE



	rcall compare_XY16		; ...

	breq duration_mismatch		;     X=Y 
	brcs menshe_26DE		;     X<Y
	rjmp duration_mismatch		;     X>Y 




menshe_26DE:				;   

;         


	cpi FlagFazy, 1			;   ?
	brne channel_2_on		;  ,    



;******************************************************************************************************
;  
;******************************************************************************************************

	
channel_1_on:				;   


	in Temp, PINB			;   "B"


	andi Temp, 0b11111110		;  "1"   ,  "0"   ! () 


	ldi Temp1, 0b00000001		;


	OR Temp, Temp1			; _ 


	out PortB,Temp			;   




	ldi FlagFazy, 2			;    


	rjmp out_1			; 





channel_2_on:				;   



	in Temp, PINB			;   "B"


	andi Temp, 0b11111101		;  "1"   ,  "0"   ! () 


	ldi Temp1, 0b00000010		;


	OR Temp, Temp1			; _ 


	out PortB,Temp			;   




	ldi FlagFazy, 0			;   


	rjmp out_1			; 




;**************************************************************************************************************
;  
;**************************************************************************************************************

duration_mismatch:			;  
					;    


	ldi FlagFazy, 0			;   ( 0=, 1= , 2=  )

	Ldi FlagSinhr, 0		;   ( 0= , 1= )


	rjmp out_1			; 




;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    




;*****************************************************************************************
;   16-- .
;*****************************************************************************************


compare_XY16:

	cp Temp,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            



;*****************************************************************************************



